####
#### Credits: Viktor Gal
####


import sys
import pandas as pd
from sklearn.ensemble import RandomForestClassifier
from sklearn.svm import LinearSVC
from sklearn.model_selection import train_test_split
from sklearn.metrics import accuracy_score
from sklearn.preprocessing import LabelEncoder
from xgboost import XGBClassifier

from mlsconverters import export

import pickle


# input processing
cat = LabelEncoder()
df = pd.read_csv(sys.argv[1])
label_column = sys.argv[2]
X = df.loc[:, df.columns != label_column].values
y = cat.fit_transform(df[label_column])
X_train, X_test, y_train, y_test = train_test_split(
    X, y, test_size=0.33, random_state=42
)

# model creation
model_name = sys.argv[3]
print("You chose the " + model_name + " model.")
model = eval(model_name + "()")
model.fit(X_train, y_train)

# model eval
y_pred = model.predict(X_test)
acc = accuracy_score(y_test, y_pred)
print("Accuracy: ", acc)

export(model, force=True, evaluation_measure=(accuracy_score, acc))

with open(sys.argv[4], "wb") as f:
    pickle.dump(model, f)
